package biss;

import java.util.NoSuchElementException;

public class LongHashtab
  extends PrimHashtab
{
	long[] Keys;
	long Subtract;

public LongHashtab () {
	super( 17, 0);
}

public LongHashtab ( int entryGuess ) {
	super( entryGuess, 0);
}

public LongHashtab ( int entryGuess, long subtract, int leftShift ) {
  super( entryGuess, leftShift);

	Subtract = subtract;
}

public synchronized boolean containsKey ( long key ) {
	return (indexOf( key, false) >= 0);
}

protected Object createKeyArray ( int n ) {
	Keys = new long[n];
  return Keys;
}

public synchronized Object get ( long key ) {
	int i = indexOf( key, false);
	return (i >= 0) ? Values[i] : null;
}

boolean grow () {
	int m = Values.length;
	int n = m * 3 / 2;
	int i, k;
	Object v;

	if ( m > 14983 ) return false;

	LongHashtab newHt = new LongHashtab( n, Subtract, LeftShift);
	
	for ( i=0, k=Count; i<m; i++ ) {
		if ( (v = Values[i]) != null && v != RecycledEntry ) {
			newHt.put( Keys[i], v);
			if ( --k == 0 ) break;
		}
	}
	
	Values = newHt.Values;
	Keys   = newHt.Keys;
	
	return true;
}

final private int indexOf ( long key, boolean newOne ) {
	long   k = key;
	int    m = Values.length, m2 = m >> 1;
	int    i, j = 0, d = 1;
	Object v;

	if ( Subtract > 0  ) k -= Subtract;
	if ( LeftShift > 0 ) k <<= LeftShift;
	i = (int) (k % m);

  do {
		if ( (v = Values[i]) == null ){
			return (newOne) ? i : -1;
		}
		else if ( v == RecycledEntry ) {
			if ( newOne ) return i;
		}
		else if ( Keys[i] == key ) {
			return i;
		}
		
		i += d; d += 2;
		if ( i >= m )
			i %= m;
	}
	while ( ++j <= m2 );
	
	return -1;
}

public synchronized Object put ( long key, Object value ) {
	int     i;
	Object  v;

	do {
		if ( (i = indexOf( key, true)) >= 0 ) {
			v = Values[i];
			Values[i] = value;
			if ( v != null ) {
				return v;
			}
			else {
				Keys[i] = key;
				Count++;
				return null;
			}
		}
	}
	while ( grow() ); // no space available any more
	
	throw new NullPointerException();
}

public synchronized Object remove ( long key ) {
	int i = indexOf( key, false);

	if ( i >= 0 ) {
		Object v = Values[i];
		Values[i] = RecycledEntry;
		Keys[i] = 0;
		Count--;
		return v;
	}
	else
		return null;
}
}
