package biss.awt;

import biss.FileLib;
import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.applet.AudioClip;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Panel;
import java.io.File;
import java.net.URL;
import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * very crude and preliminary class to test the java.awt.peer role of
 * biss.awt classes. Has to be called like:
 *          java biss.awt.AppletViewer <AppletClass>
 * (i.e. with the class name instead of the html file). It does not
 * provide any parameter mechanism yet.
 * Will be extended towards standard 'appletviewer' compatibility
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class AppletViewer
  extends TopWindow
  implements AppletStub, AppletContext, Observer
{
	Applet App;
	Vector Apps = new Vector();
	String AppCls;
	URL Base;
	Layouter Lo = new Layouter( this);
	Panel Client = new Panel();
	BarMenu BMenu = new BarMenu();
	Label State = new Label();

public AppletViewer ( File html) {
	
	super( "AppletViewer: " + html);
	setBarMenu();
	
	try {
		boolean go = false;
		int w = 0;
		int h = 0;
		String s = FileLib.getFileDataAsString( html);
		StringTokenizer st = new StringTokenizer( s, " \r\n\t=>");
		while ( st.hasMoreElements() ){
			String tok = st.nextToken();
			if ( tok.equalsIgnoreCase( "<applet"))
				go = true;
			else if ( go) {
				if ( tok.equalsIgnoreCase( "code")){
					AppCls = st.nextToken();
					if ( AppCls.endsWith( ".class"))
						AppCls = AppCls.substring( 0, AppCls.length()-6);
				}
				else if ( tok.equalsIgnoreCase( "height"))
					h = Integer.parseInt( st.nextToken() );
				else if ( tok.equalsIgnoreCase( "width"))
					w = Integer.parseInt( st.nextToken() );
			}
		}
		Class c = Class.forName( AppCls);
		App = (Applet) c.newInstance();
		App.setStub( this);
		Apps.addElement( App);
		
		int bh = (150*Awt.DlgYUnit+50)/100;
		Lo.add( BMenu, 0, 0, 1000, 0, false, 0, 0, 0, bh, 0);
		Lo.add( App, 0, 0, 1000, 1000, false, 0, bh, 0, -bh, 0);
		Lo.add( State, 0, 1000, 1000, 1000, false, 0, -bh, 0, 0, 0);
		 
		init();
//		pack();
		Insets in = getInsets();
// System.out.println( in);		
		setBounds( 100, 100, w+in.left+in.right, h+in.top+in.bottom+2*bh);
		setVisible( true);
App.doLayout();
		
		BMenu.OsCommand.addObserver( this);
		showStatus( "Applet started");
	}

	catch( Throwable t) {
		System.out.println( t);
	}
}

public void appletResize ( int width, int height) {
	System.out.println( "appletResize");
}

public Applet getApplet ( String name) {
	return App;
}

public AppletContext getAppletContext () {
	return this;
}

public Enumeration getApplets () {
	return Apps.elements();
}

public AudioClip getAudioClip ( URL url) {
	return null;
}

public URL getCodeBase () {
	return Base;
}

public URL getDocumentBase () {
	return Base;
}

public Image getImage ( URL url) {
	return Awt.DefToolkit.getImage( url );
}

public String getParameter ( String name) {
	// System.out.println( name);
	return null;
}

void init(){
	try {
		String curDir = System.getProperty( "user.dir");
		Base = new URL( "file", "localhost", curDir + "/" );
		App.init();
		App.start();
	}
	catch( Throwable t) {}
}

public boolean isActive () {
	return true;
}

public static void main ( String[] args) {
	if ( args.length == 0)
		System.out.println( "usage: AppletViewer <html file>");
	else {
		File f = new File( args[0] );
		if ( f.exists() )
			new AppletViewer( f);
		else
			System.out.println( "file " + f + " does not exist");
	}
}

void setBarMenu () {
	Menu ma = new Menu();
	Menu m = new Menu( "Applet");
	m.add( "Restart");
	m.add( "Reload");
	m.add( "Stop");
	m.add( "Save...");
	m.add( "Start");
	m.add( "Clone...");
	m.addSeparator();
	m.add( "Tag...");
	m.add( "Info...");
	m.add( "Edit");
	m.add( "Character Encoding");
	m.addSeparator();
	m.add( "Print...");
	m.addSeparator();
	m.add( "Properties...");
	m.addSeparator();
	m.add( "Close");
	m.add( "Quit");
	
	ma.add( m);
	BMenu.setContents( ma);
}

public void showDocument ( URL url) {
}

public void showDocument ( URL url, String target) {
}

public void showStatus ( String str) {
	State.setContents( str);
}

public void update ( Observable obs, Object arg ) {
	if ( obs == BMenu.OsCommand) {
		if ( "Quit".equals( arg))
			System.exit( 0);
		else if ( "Stop".equals( arg)) {
			App.stop();
			showStatus( "Applet stopped");
		}
		else if ( "Start".equals( arg)) {
			App.start();
			showStatus( "Applet started");
		}
	}
}
}
