package biss.awt;

import java.awt.AWTEvent;
import java.awt.EventQueue;
import java.awt.peer.ActiveEvent;
import java.lang.reflect.*;

public class AsyncMethodInvocation
{
	InvocationEvent Handler;
	EventQueue Queue;

public AsyncMethodInvocation ( Object target, String mthName, Class[] parTypes) {
	try {
		Class tc = target.getClass();
		java.lang.reflect.Method mth = tc.getMethod( mthName, parTypes);
		Handler = new InvocationEvent( this, target, mth);
		Queue = Awt.DefToolkit.getSystemEventQueue();
	}
	catch( Exception e) {
		Queue = null;
	}
}

public static void main ( String[] args ) {
	TopWindow t = new TopWindow( "ReflectTest");
	t.setBounds( 100, 100, 200, 200);
	
	Class[] ca = { java.lang.Boolean.TYPE };
	AsyncMethodInvocation rc = new AsyncMethodInvocation( t, "setVisible", ca);
	
	Object[] oa = { new Boolean( true) };
	rc.process( oa);
}

public void process ( Object[] params) {
	Handler.Params = params;
	if ( Queue != null)
		Queue.postEvent( Handler);
	else
		Handler.dispatch();
}
}

class InvocationEvent
  extends AWTEvent
  implements ActiveEvent
{
	java.lang.reflect.Method Mth;
	Object[] Params;
	Object Target;

public InvocationEvent ( AsyncMethodInvocation cmd, Object target, java.lang.reflect.Method mth) {
	super( cmd, 0);
	Target = target;
	Mth = mth;
}

public void dispatch() {
	try {
		Mth.invoke( Target, Params);
	}
	catch( Exception e) {
	}
}
}
