package biss.awt;

import java.awt.Color;
import java.awt.Graphics;

/**
 * static decoration box
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class DecoBox
  extends Decoration
{
	Border BoxBorder = new Border();

public DecoBox () {
	this( Border.BS_CARVED );
}

public DecoBox ( int style) {
	setBorder( style);
}

public void blank (Graphics g, Color cb) {
	BoxBorder.blankBorder( g, 0, 0, Width, Height, cb);
}

/**
 * exclude DecoBox from lightweight dispatching ( use inner parts )
 */
public boolean contains( int x, int y){
	return false;
}

public void drawBorder (Graphics g) {
	BoxBorder.drawBorder( g, 0, 0, Width, Height);
}

public void paint (Graphics g) {
	if ( isShowing() )
		drawBorder( g);
}

public void setBorder ( int border) {
	BoxBorder.setBorder( border);
	if ( isShowing() )
		repaint();
}
}
