package biss.awt;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Label;
import java.awt.image.ImageObserver;

/**
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author P.C.Mehlitz
 */
abstract public class Decoration
  extends Component
  implements ImageObserver
{
	protected int Width;
	protected int Height;

protected Decoration () {
}

public void blank () {
	Graphics g = getGraphics();
	blank( g, getParent().getBackground() );
	g.dispose();
}

public void blank (Graphics g, Color cb) {
	g.setColor( cb );
	g.fillRect( 0, 0, Width+1, Height+1);
}

public boolean imageUpdate ( Image img, int infoflags, int x, int y,
		      int width, int height) {

	if ( infoflags == 3) //( width and height)
		Awt.DefToolkit.prepareImage( img, width, height, this);

	if ( (infoflags & ImageObserver.ABORT) > 0 )
		return false;

	boolean ready = ( (infoflags & ImageObserver.ALLBITS) > 0);
	if ( isShowing() && ready)
		repaint();

	return !ready;
}

/**
    providing a specialized paint method is the only responsibility of
    Decoration derived classes
    */
abstract public void paint ( Graphics g );

/**
    reshape is resolved to shadow the coordinates of this object. This is done
    not just to make these fields available to derived classes of other packages,
    but also to blank the old contents prior to a reshape (objet might have
    been shifted or moved, parent has to be redrawn correctly)
    */
public void setBounds ( int x, int y, int w, int h ) {

	Width = w;
	Height = h;

	super.setBounds(x, y, w, h);
}
}
