package biss.awt;

import biss.ObserverSocket;
import java.awt.Graphics;

/**
 * generic draw panel via ObserverSocket
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class GraphPane
  extends Widget
{
/**
 * triggered by painting. The observer is responsible for
 * any GraphPane painting.
 * parameter: Graphics
 */
	public ObserverSocket OsDraw = new ObserverSocket( this);
	public ObserverSocket OsReshape = new ObserverSocket( this);

public GraphPane(){
	FBorder.setBorder( Border.BS_INSET);
}

protected void redraw( Graphics g){
	blank( g);
	OsDraw.notifyObservers( g);
}

public void setBounds( int x, int y, int width, int height) {
	super.setBounds( x, y, width, height);
	
	// mechanism to adapt Panners / info components etc.
	// to the changed size of a GraphPane instance.
	// This should not be misused to bypass a LayoutManager,
	// i.e. to resize other components according to this
	// notification (they might be resized afterwards by
	// a LayoutManager anyway).
	OsReshape.notifyObservers();
}
}
