package biss.awt;

import java.awt.Event;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

/**
 * auxiliary class with keyboard constants
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class Key
{
	final public static int Backspace = KeyEvent.VK_BACK_SPACE;
	final public static int CursorDown = KeyEvent.VK_DOWN;
	final public static int CursorLeft = KeyEvent.VK_LEFT;
	final public static int CursorRight = KeyEvent.VK_RIGHT;
	final public static int CursorUp = KeyEvent.VK_UP;
	final public static int Delete = KeyEvent.VK_DELETE;
	final public static int End = KeyEvent.VK_END;
	final public static int Escape = KeyEvent.VK_ESCAPE;
	final public static int Home = KeyEvent.VK_HOME;
	final public static int Newline = KeyEvent.VK_ENTER;
	final public static int PageDown = KeyEvent.VK_PAGE_DOWN;
	final public static int PageUp = KeyEvent.VK_PAGE_UP;
	final public static int Tab = KeyEvent.VK_TAB;
	final public static int F1 = KeyEvent.VK_F1;
	final public static int F2 = KeyEvent.VK_F2;
	final public static int F3 = KeyEvent.VK_F3;
	final public static int F4 = KeyEvent.VK_F4;
	final public static int F5 = KeyEvent.VK_F5;
	final public static int F6 = KeyEvent.VK_F6;
	final public static int F7 = KeyEvent.VK_F7;
	final public static int F8 = KeyEvent.VK_F8;
	final public static int F9 = KeyEvent.VK_F9;
	final public static int F10 = KeyEvent.VK_F10;
	final public static int F11 = KeyEvent.VK_F11;
	final public static int F12 = KeyEvent.VK_F12;
	public static int ActiveKey = 0;
	public static int ActiveKeyMods = 0;
	final public static int Insert = KeyEvent.VK_INSERT;

public static boolean isAlphaNumKey ( int key) {
	if ( (key >= 32) && (key <=126) )
		return true;
	if ( (key >= 192) && (key <= 255) )
		return true;
	return false;
}

public static boolean isAltDown ( int mod) {
	return (( mod & InputEvent.META_MASK) != 0);
}

public static boolean isCtrlDown() {
	return ((ActiveKeyMods & InputEvent.CTRL_MASK) != 0);
}

public static boolean isCtrlDown ( int mod) {
	return (( mod & InputEvent.CTRL_MASK) != 0);
}

public static boolean isLoneKey ( int mod) {
	return ( mod == 0);
}

public static boolean isShiftDown() {
	return ((ActiveKeyMods & InputEvent.SHIFT_MASK) != 0);
}

public static boolean isShiftDown ( int mod) {
	return (( mod & InputEvent.SHIFT_MASK) != 0);
}

public static boolean isVKey( KeyEvent e) {
	int kc = (int)e.getKeyChar();
	
	if ( 	( kc == KeyEvent.VK_ENTER) ||
		( kc == 10) || (kc == 13) ||
		( kc == KeyEvent.VK_BACK_SPACE) ||
		( kc == KeyEvent.VK_TAB) ||
		( kc == KeyEvent.VK_ESCAPE) ||
		( kc == KeyEvent.VK_DELETE) )
		return true;
	return false;
}
}
