package biss.awt;

import biss.awt.Awt;
import biss.awt.Button;
import biss.awt.DialogWindow;
import biss.awt.Layouter;
import biss.awt.List;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

/**
 * generic dialog to choose from a list of objects
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class ListPrompter
  extends DialogWindow
{
	List ItemPane = new List();
	Button EnterBtn = new Button("~Ok");
	Button CancelBtn = new Button("~Cancel");
	Object Selection;

public ListPrompter ( String label, Vector list, Frame owner) {
	this( label, list, owner, true);
}

public ListPrompter ( String label, Vector list, Frame owner, boolean editable) {
	super( owner, label, DISPATCHED);
	ItemPane.setContents( list);
	if ( editable)
		setEditMenu();
	open();
}

public Vector getContents () {
	if ( WasCanceled)
		return null;
	return ItemPane.getContents();
}

public Object getSelection () {
	if ( WasCanceled)
		return null;
	return Selection;
}

void init() {
	EnterBtn.OsAction.addObserver( this);
	CancelBtn.OsAction.addObserver( this);
	ItemPane.OsProcess.addObserver( this);

	setDlgUnitCenterBounds( 1480, 1693);
	DefCom = ItemPane;
}

public static void main (String[] args) {
	Frame fr = new Frame ( "OwnerFrame");
	Vector v = new Vector();
	for ( int i=0; i<10; i++)
		v.addElement( "this is item number " + i);
	fr.setBounds( 100, 100, 100, 100);
	fr.show();
	ListPrompter pr = new ListPrompter( "Please select:", v, fr);
	System.out.println( pr.getSelection() );
	System.exit( 0);
}

public void open() {
	Lo.add( ItemPane, 0, 0, 1000, 1000, true, 0, 0, 0, -233, 0);
	Lo.add( EnterBtn, 0, 1000, 509, 1000, true, 120, -213, -40, -13, 0);
	Lo.add( CancelBtn, 509, 1000, 1000, 1000, true, 20, -213, -113, -13, 0);

	init();

	Rectangle bounds = getBounds();

	if ( bounds.width > 0)
		setVisible( true);
	else {
		bounds.setBounds( 1250, 1810, 1476, 1690);
		Awt.toPixelUnits( bounds);
		setBounds( bounds);
		setVisible( true);
	}
}

void setEditMenu() {

	Menu m = new Menu();
	m.add( "~up");
	m.add( "~down");
	m.add( "~remove");
	
	ItemPane.addHotKey( Key.Delete, HotKey.Lone, "remove");
	ItemPane.addHotKey( Key.CursorUp, HotKey.Shift, "up");
	ItemPane.addHotKey( Key.CursorDown, HotKey.Shift, "down");
	
	setMenu( m, this);
}

public void setMenu( Menu m, Observer obs) {
	ItemPane.Cv.setMenu( m);
	if ( obs != null)
		ItemPane.OsCommand.addObserver( obs);
}

public void update ( Observable obs, Object arg) {
	if ( obs == EnterBtn.OsAction ) {
		Selection = ItemPane.getSelection();
		process();
	}
	else if ( obs == CancelBtn.OsAction ) {
		WasCanceled = true;
		process();
	}
	else if ( obs == ItemPane.OsProcess ) {
		Selection = ItemPane.getSelection();
		process();
	}
	else if ( obs == ItemPane.OsCommand) {
		if ( arg.equals( "up"))
			ItemPane.shiftUp();
		else if ( arg.equals( "down"))
			ItemPane.shiftDown();
		else if ( arg.equals( "remove"))
			ItemPane.removeElement( ItemPane.getSelection() );
	}
}
}
