package biss.awt;

import java.awt.Point;
import java.awt.event.MouseEvent;

/**
 * helper class for handling / controlling mouse input 
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class Mouse
{
	public static int ActiveButton = 0;
	public static int ClickCount = 0;
	static int ClickTime = 200;
	static int DblClickTime = 400;
	static long LastDown = 0;
	static long LastUp = 0;
	public static Point Pos = new Point();
	public static MouseEvent LastEvent;

public static void down ( MouseEvent e) {
	LastDown = System.currentTimeMillis();
	ClickCount = e.getClickCount();
	updateActiveButton( e.getModifiers() );
}

public static void down ( int active, int cc) {
	LastDown = System.currentTimeMillis();
	ClickCount = cc;
	ActiveButton = active;
}

public static int getActiveButton ( int mod) {
	switch( mod) {
		case MouseEvent.BUTTON2_MASK:
			return 2;
		case MouseEvent.BUTTON3_MASK:
			return 3;
	}

	//Motif mousePressed() mods are 0 for button1
	return 1;
}

public static boolean is1Active() {
	return ActiveButton == 1;
}

public static boolean is2Active() {
	return ActiveButton == 2;
}

public static boolean is3Active() {
	return ActiveButton == 3;
}

public static boolean isAnyActive() {
	return (ActiveButton != 0);
}

public static boolean isLeftActive() {
	return (ActiveButton == 1);
}

public static boolean isMiddleActive() {
	return (ActiveButton == 2);
}

public static boolean isRightActive() {
	return (ActiveButton == 3);
}

public static void reset () {
	ActiveButton = 0;
}

public static void up () {
	long dt = System.currentTimeMillis();
	if ( dt - LastUp < DblClickTime)
		ClickCount = 2;
	else if ( dt - LastDown < ClickTime)
		ClickCount = 1;
	else
		ClickCount = 0;

	LastUp = dt;
}

public static void updateActiveButton ( int mod) {
	ActiveButton = getActiveButton( mod);	
}

public static boolean wasClicked() {
	return ClickCount == 1;
}

public static boolean wasDblClicked() {
	return ClickCount == 2;
}

public static boolean wasLast( int evtID) {
	if ( LastEvent != null)
		return LastEvent.getID() == evtID;
	return false;
}
}
