package biss.awt;

import biss.Command;
import biss.CommandQueue;
import java.awt.AWTEvent;
import java.awt.EventQueue;
import java.awt.peer.ActiveEvent;

public class RepeatCommand
  implements Command
{
	int Delay = Awt.ScrollDelay;
	int InitDelay = Awt.ScrollInitDelay;
	RepeatInterface Client;
	boolean StopIt;
	int DefDelay;
	int Rounds;
	EventQueue Queue;
	RepeatEvent Repeater;

class RepeatEvent
  extends AWTEvent
  implements ActiveEvent
{
public RepeatEvent ( Object src ) {
	super( src, 0);
}

public void dispatch() {
	actionNotify();
	Awt.DefToolkit.sync();
	consume();
}
}

public RepeatCommand ( RepeatInterface client) {
	this( client, true);
}

public RepeatCommand ( RepeatInterface client, boolean drawSynced) {
	Client = client;
	if ( drawSynced) {
		try {
			Queue = Awt.DefToolkit.getSystemEventQueue();
			Repeater = new RepeatEvent( this);
		}
		catch ( Exception e) {
			Repeater = null;
		}
	}
}

public void actionNotify () {
	if ( Client != null)
		Client.repeat();
	repeat();
}

public boolean execute () {
	if (++Rounds == 2)
		CommandQueue.setDelay( Delay);
		
	if ( Repeater != null)
		Queue.postEvent( Repeater);
	else 
		actionNotify();

	return true;
}

public int getRounds () {
	return Rounds;
}

public boolean isRunning () {
	return !StopIt;
}

public void repeat () {
	if ( ! StopIt)
		CommandQueue.appendUnique( this);			
}

public void setDelay ( int d) {
	Delay = d;
}

public void setInitDelay ( int d) {
	InitDelay = d;
}

public void start () {
	StopIt = false;
	Rounds = 0;
	DefDelay = CommandQueue.getDelay();
	CommandQueue.setDelay( InitDelay);
	CommandQueue.append( this);
}

public void stop () {
	StopIt = true;
	CommandQueue.setDelay( DefDelay);
}
}
