package biss.awt;

import biss.awt.Awt;
import biss.awt.Label;
import biss.awt.Layouter;
import biss.awt.TextField;
import biss.awt.TopWindow;
import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;

public class TextPromptWnd
  extends TopWindow
{
	Layouter Lo = new Layouter( this);
	Label TP = new Label("");
	TextField Entry = new TextField("");
	boolean WasCanceled = true;
	LocalDispatcher LD;

public TextPromptWnd( String title, String text, String defCont, TopWindow owner){
	this( title, text, defCont, true, null, owner);
}

public TextPromptWnd(String title, String text, String defCont, boolean defSel, Object checker) {
	this( title, text, defCont, defSel, checker, null);
}

public TextPromptWnd(String title, String text, String defCont, boolean defSel, Object checker, TopWindow owner) {
	super( title, owner);
	
//	try {
//		Thread.sleep( 1000);
//	} catch (Exception e) {}

 	open();

	TP.setContents( text);

	if ( defCont != null) {
		Entry.setContents( defCont);
		if ( defSel)
			Entry.selectContents();
	}

	if ( checker != null)
		Entry.setChecker( checker);

}

public TextPromptWnd( String text, String defCont, TopWindow owner){
	this( "Please enter:", text, defCont, true, null, owner);
}

public String getContents(){
	if ( WasCanceled)
		return null;
	return Entry.getContents();
}

public int getContentsAsInt() {
	try { return Integer.parseInt( Entry.getContents() ); }
	catch ( Exception e) { return -1; }
}

public String getNonEmptyContents(){
	if ( ! WasCanceled){
		String c = Entry.getContents();
		if ( ( c != null) && ( c.length() > 0) )
			return c;
	}
	return null;
}

public void init() {
	OsOpen.addObserver( this);
	OsClose.addObserver( this);
	
	TP.wrapContents();
	TP.setCarved( false);
	TP.setBorder( Border.BS_NONE);
	TP.setAlignment( Label.HA_CENTER, Label.VA_CENTER);

	Entry.FBorder.setBorder( Border.BS_STEP);
	Entry.OsEnter.addObserver( this);
	Entry.OsReset.addObserver( this);
}

public static void main( String[] args) {

	TopWindow win = new TopWindow( "Owner");
	Rectangle bounds = win.getBounds();
	bounds.setBounds( 184, 2778, 1540, 646);
	Awt.toPixelUnits( bounds);
	win.setBounds( bounds);
	win.setVisible( true);

	
	String txt = "Please type your lastname, userID or password";
	String def = "Gonzo";
	TextPromptWnd tp = new TextPromptWnd( "My Prompter", txt, def, true, win);
	System.out.println( tp.getNonEmptyContents() );

}

public void open() {
	Lo.add( TP, 0, 0, 1000, 1000, true, 18, 18, -12, -193, 0);
	Lo.add( Entry, 0, 1000, 1000, 1000, true, 18, -175, -12, -6, 0);

	init();

	Rectangle bounds = getBounds();

	if ( bounds.width > 0)
		setVisible( true);
	else {
		bounds.setBounds( 184, 2778, 1540, 646);
		Awt.toPixelUnits( bounds);
		setBounds( bounds);
		setVisible( true);
	}
}

public void process() {
	try { Thread.sleep( 50);} catch ( Exception e) {}
	LD = new LocalDispatcher();
	LD.dispatchTilTerminate();
}

public void update( Observable o, Object arg){

	if        ( o == OsOpen) {
		process();
	} else if ( o == OsClose) {
		LD.terminate();
	} else if ( o == Entry.OsEnter ) {
		WasCanceled = false;
		dispose();
	} else if ( o == Entry.OsReset ){
		dispose();
	}
}
}
