package biss.awt;

import biss.awt.Awt;
import biss.awt.Button;
import biss.awt.DecoText;
import biss.awt.DialogWindow;
import biss.awt.Layouter;
import biss.awt.TextField;
import java.awt.Frame;
import java.awt.Rectangle;
import java.util.Observable;
import java.util.Observer;

/**
 * physical view of the standard biss.awt.TextArea replace dialog
 *
 * (C) 1996,97 BISS GmbH Germany, see file 'LICENSE.BISS-AWT' for details
 * @author J.H.Mehlitz
 */
public class TextReplacer
  extends DialogWindow
{
	TextField CFindTxt = new TextField();
	TextField CRepTxt = new TextField();
	Button CRep = new Button("~Replace");
	Button CRepAll = new Button("Replace ~All");
	Button CExit = new Button("~Exit");
	DecoText TFind = new DecoText("Find:");
	DecoText TRep = new DecoText("Replace:");
	final public static int FIND = 0;
	final public static int REPLACE = 1;
	final public static int REPLACE_ALL = 2;
	Button CFind = new Button("~Find");
	int Action;

public TextReplacer( Frame owner, String defCont, Observer obs) {
	super( owner, "Find/Replace", OWNED);

	if ( obs != null)
		OsCommand.addObserver( obs);
	CRep.OsAction.addObserver( this);
	CRepAll.OsAction.addObserver( this);
	CFind.OsAction.addObserver( this);
	CExit.OsAction.addObserver( this);
	
	if ( defCont != null) {
		CFindTxt.setContents( defCont);
		CFindTxt.selectContents();
	}
	open();
}

public int getAction() {
	return Action;
}

public String getFindText() {
	return CFindTxt.getContents();
}

public String getReplaceText() {
	return CRepTxt.getContents();
}

public void init() {
	setDlgUnitCenterBounds( 1860, 806);
	DefCom = CFindTxt;
}

public static void main( String[] args) {
	Frame fr = new Frame( "OwnerFrame");
	fr.setBounds( 100, 100, 100, 100);
	fr.show();
	TextReplacer tr = new TextReplacer( fr, "hallo", null);
/*
	System.out.println( tr.getAction() );
	System.out.println( tr.getOriginText() );
	System.out.println( tr.getReplaceText() );	
	System.exit( 0);
*/
}

public void open() {
	Lo.add( CFindTxt, 0, 0, 1000, 0, true, 380, 20, -40, 200, 0);
	Lo.add( CRepTxt, 0, 0, 1000, 0, true, 380, 220, -40, 400, 0);
	Lo.add( CRep, 0, 0, 0, 0, true, 460, 420, 880, 600, 0);
	Lo.add( CRepAll, 0, 0, 0, 0, true, 900, 420, 1320, 600, 0);
	Lo.add( CExit, 0, 0, 0, 0, true, 1340, 420, 1760, 600, 0);
	Lo.add( TFind, 0, 0, 0, 0, true, 20, 20, 380, 200, 0);
	Lo.add( TRep, 0, 0, 0, 0, true, 20, 220, 380, 400, 0);
	Lo.add( CFind, 0, 0, 0, 0, true, 20, 420, 440, 600, 0);

	init();

	Rectangle bounds = getBounds();

	if ( bounds.width > 0)
		setVisible( true);
	else {
		bounds.setBounds( 3, 2283, 1856, 803);
		Awt.toPixelUnits( bounds);
		setBounds( bounds);
		setVisible( true);
	}
}

public void update( Observable obs, Object arg){
	if ( obs == CFind.OsAction){
		Action = FIND;
		OsCommand.notifyObservers( this);
	}
	else if ( obs == CRep.OsAction){
		Action = REPLACE;
		OsCommand.notifyObservers( this);
	}
	
	else if ( obs == CRepAll.OsAction){
		Action = REPLACE_ALL;
		OsCommand.notifyObservers( this);
		process();
	}
	else if ( obs == CExit.OsAction){
		WasCanceled = true;
		process();
	}
}
}
